SystemOrganization addCategory: #CiSics!
SystemOrganization addCategory: #'CiSics-Event'!
SystemOrganization addCategory: #'CiSics-Examples'!
SystemOrganization addCategory: #'CiSics-Roassal'!

!Point methodsFor: '*cisics' stamp: 'cipt 10/12/2012 23:41'!
asParticle
	^CiParticle position: self.! !

Announcement subclass: #CiEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics-Event'!

CiEvent subclass: #CiSystemChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics-Event'!

Object subclass: #CiExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics-Examples'!

!CiExample methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 15:55'!
cloth
	"							self new cloth  						"

	| sStrength sDamp particles canvas p springs system edges nbNodes ii |
	sStrength := 5.
	sDamp := 0.0001.
	nbNodes := 15.
	p := OrderedCollection new.
	particles := (1 to: nbNodes)
		collect: [ :i | 
			(1 to: nbNodes)
				collect: [ :j | 
					p add: (CiParticle position: (i * 15) @ (j * 15)).
					] ].
	springs := OrderedCollection new.
	edges := OrderedCollection new.
	1 to: nbNodes do: [ :i | 
		1 to: nbNodes do: [ :j | 
			j > 1
				ifTrue: [ 
					springs
						add:
							(CiSpring
								from: ((particles at: i) at: j - 1)
								to: ((particles at: i) at: j)
								length: 15
								k: sStrength
								damping: sDamp).
					 ] ] ].
	1 to: nbNodes do: [ :j | 
		2 to: nbNodes do: [ :i | 
			springs
				add:
					(CiSpring
						from: ((particles at: i - 1) at: j)
						to: ((particles at: i) at: j)
						length: 15
						k: sStrength
						damping: sDamp).
			 ] ].
	((particles at: 1) at: 1) fix.
	((particles at: nbNodes) at: 1) fix.
	((particles at: nbNodes) at: 1) position: (nbNodes * 15) @ 15.

	system := CiParticleSystem new
		initialize;
		integrator: CiEulerIntegrator new;
		particles: p;
		springs: springs;
		gravity: 0 @ 8.
	
	canvas := CiParticleSystemView new
		system: system;
		open.
	system simulate! !

!CiExample methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 15:56'!
example1
	"		self new example1			"

	| p q r s t v canvas system |
	p := CiParticle position: 200 @ 200.
	q := CiParticle position: 400 @ 400.
	r := CiParticle position: 150 @ 300.
	s := CiSpring
		from: p
		to: q
		length: 60
		k: 0.09
		damping: 0.0001.
	t := CiSpring
		from: p
		to: r
		length: 60
		k: 0.09
		damping: 0.0001.
	v := CiSpring
		from: r
		to: q
		length: 60
		k: 0.09
		damping: 0.0001.
	system := CiParticleSystem new
		initialize;
		deltaT: 1/1000;
		particles: {p. q. r};
		springs: {s. t. v}.

	canvas := CiParticleSystemView new
		system: system;
		open.
	system simulate! !

!CiExample methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 15:57'!
example2
	"		self new example2			"

	| p q r s t v canvas system e |
	p := CiParticle position: 200 @ 200.
	q := CiParticle position: 400 @ 400.
	s := CiSpring
		from: p
		to: q
		length: 60
		k: 5
		damping: 0.0001.
	p fix.
	system := CiParticleSystem new
		initialize;
		particles: {p. q};
		springs: {s};
		deltaT: 1 / 20000.
	canvas := CiParticleSystemView new
		system: system;
		open.
	system simulate! !

!CiExample methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 19:46'!
example3
	"		self new example3 				"

	| p q r s t v canvas system |
	p := CiParticle position: 200 @ 200.
	q := CiParticle position: 400 @ 400.
	r := CiParticle position: 150 @ 300.
	s := CiSpring
		from: p
		to: q
		length: 20
		k: 0.5
		damping: 0.0002.
	t := CiSpring
		from: p
		to: r
		length: 60
		k: 0.09
		damping: 0.0001.
	v := CiSpring
		from: r
		to: q
		length: 60
		k: 0.09
		damping: 0.0001.
	system := CiParticleSystem new
		initialize;
		deltaT: 1 / 10000;
		particles: {p. q. r};
		springs: {s. t. v}.
	canvas := CiParticleSystemView new
		system: system;
		open.
	system simulate! !

!CiExample methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 15:55'!
example4
	"		self new example4 				"

	| p q r s t v x canvas system |
	p := CiParticle position: 200 @ 200 mass: 10.
	q := CiParticle position: 400 @ 400 mass: 10.
	x := CiAttraction between: p and: q strength: 5000.
	system := CiParticleSystem new
		initialize;
		deltaT: 1/1000;
		particles: {p. q};
		attractions: {x};
		friction: 10.
	canvas := CiParticleSystemView new
		system: system;
		open.
	system simulate! !

!CiExample methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 20:40'!
exampleAttraction2
	"		self new exampleAttraction2 				"

	| p q r s t v x canvas system |
	p := CiParticle position: 200 @ 200 mass: 10.
	q := CiParticle position: 400 @ 400 mass: 10.
	x := CiAttraction between: p and: q strength: ((p - q) r).
	system := CiParticleSystem new
		initialize;
		deltaT: 0.07;
		particles: {p. q};
		attractions: {x};
		friction: 10.
	canvas := CiParticleSystemView new
		system: system;
		open.
	system simulate! !

!CiExample methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 20:40'!
exampleAttraction3
	"		self new exampleAttraction3				"

	| p q r s t v x canvas system |
	p := CiParticle position: 200 @ 200 mass: 10.
	q := CiParticle position: 400 @ 400 mass: 10.
	x := CiAttraction between: p and: q strength: ((p dist: q) abs squared ).
	system := CiParticleSystem new
		initialize;
		deltaT: 0.0004;
		particles: {p. q};
		attractions: {x};
		friction: 10.
	canvas := CiParticleSystemView new
		system: system;
		open.
	system simulate! !

!CiExample methodsFor: 'as yet unclassified' stamp: 'cipt 10/11/2012 20:27'!
exampleNBody
	"		CiExample new exampleNBody 			"

	| rnd n force particles attractions system canvas |
	n := 100.
	force := [ :a :b | |f| f := 0.2 * ((a mass + b mass) / ((a dist: b) max: 1)). (a-b)   *f].
	rnd := Random new.
	particles := (1 to: n)
		collect: [ :i | 
			| pos |
			pos := (rnd nextInt: 500) @ (rnd nextInt: 500).
			CiParticle position: pos mass: 1 ].
	attractions := OrderedCollection new.
	(1 to: n)
		do: [ :i | 
			(i + 1 to: n)
				do: [ :j | attractions add: (CiDynamicAttraction between: (particles at: i) and: (particles at: j) strength: force) ] ].
	system := CiParticleSystem new
		initialize;
		deltaT: 0.1;
		particles: particles;
		attractions: attractions.
	canvas := CiParticleSystemView new
		system: system;
		open.
	system simulate! !

!CiExample methodsFor: 'as yet unclassified' stamp: 'cipt 10/14/2012 14:18'!
exampleNBody1
	"		CiExample new exampleNBody1 			"

	| rnd n particles attractions system canvas |
	n := 10.
	rnd := Random new.
	particles := (1 to: n)
		collect: [ :i | 
			| pos |
			pos := (rnd nextInt: 500) @ (rnd nextInt: 500).
			CiParticle position: pos mass: (rnd nextInt: 10) ].
	attractions := OrderedCollection new.
	(1 to: n)
		do: [ :i | 
			(i + 1 to: n)
				do: [ :j | attractions add: (CiAttraction between: (particles at: i) and: (particles at: j) strength: 10) ] ].
	system := CiParticleSystem new
		initialize;
		deltaT: 0.5;
		particles: particles;
		attractions: attractions.
	canvas := CiParticleSystemView new
		system: system;
		open.
	system simulate! !

Object subclass: #CiForce
	instanceVariableNames: 'isOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics'!

CiForce subclass: #CiAttraction
	instanceVariableNames: 'a b strength distanceMin sqDistMin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics'!

!CiAttraction class methodsFor: 'as yet unclassified' stamp: 'cipt 10/5/2012 20:54'!
between: aParticle and: anotherParticle strength: aStrength

	^self new
		initialize ;
		a: aParticle ;
		b: anotherParticle ;
		strength: aStrength ! !

!CiAttraction methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:41'!
a
	^a! !

!CiAttraction methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:41'!
a: anA 
	a := anA .! !

!CiAttraction methodsFor: 'force-computing' stamp: 'cipt 10/7/2012 15:52'!
apply
	| force length |
	(isOn and:[a isFree | b isFree]) ifTrue:[
		|a2b sqa2b|
		a2b := a - b.
		sqa2b := a2b dotProduct:   a2b  .
		sqa2b < sqDistMin ifTrue:[sqa2b := sqDistMin ].
		
		force := strength * a mass * b mass / sqa2b .
		length := (sqa2b ) sqrt .
		
		a2b := a2b / length.
		a2b := a2b * force.
		
		a isFree ifTrue:[a force: a force + (a2b negated)].
		b isFree ifTrue: [b force: b force + a2b ].
		]! !

!CiAttraction methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:41'!
b
	^b! !

!CiAttraction methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:41'!
b: aB
	b := aB .! !

!CiAttraction methodsFor: 'initialize-release' stamp: 'cipt 10/7/2012 20:49'!
initialize
	isOn := true.
	distanceMin := 5.
	sqDistMin := 25.! !

!CiAttraction methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:42'!
minimumDistance
	^distanceMin ! !

!CiAttraction methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:42'!
minimumDistance: aDist
	distanceMin := aDist.
	sqDistMin := aDist * aDist .! !

!CiAttraction methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:43'!
oneEnd
	^a! !

!CiAttraction methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:44'!
otherEnd
	^b! !

!CiAttraction methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:43'!
strength 
	^strength ! !

!CiAttraction methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:43'!
strength: aStrength 
	strength := aStrength .! !

CiAttraction subclass: #CiDynamicAttraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics'!

!CiDynamicAttraction methodsFor: 'as yet unclassified' stamp: 'cipt 10/11/2012 19:41'!
apply
	(isOn and: [ a isFree | b isFree ])
		ifTrue: [ 
			| force |
			force := self strength value: a value: b.
			a isFree
				ifTrue: [ a force: a force + force negated ].
			b isFree
				ifTrue: [ b force: b force + force ] ]! !

CiAttraction subclass: #CiOneWayAttraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics'!

!CiOneWayAttraction methodsFor: 'as yet unclassified' stamp: 'cipt 10/12/2012 23:35'!
apply
	| force length |
	(isOn and: [ a isFree ])
		ifTrue: [ 
			| a2b sqa2b |
			a2b := a - b.
			sqa2b := a2b dotProduct: a2b.
			sqa2b < sqDistMin
				ifTrue: [ sqa2b := sqDistMin ].
			force := strength * a mass * b mass / sqa2b.
			length := sqa2b sqrt.
			a2b := a2b / length.
			a2b := a2b * force.
			a isFree
				ifTrue: [ a force: a force + a2b negated ] ]! !

!CiForce methodsFor: 'force-computing' stamp: 'cipt 10/7/2012 13:56'!
apply
	^self subclassResponsibility ! !

!CiForce methodsFor: 'testing' stamp: 'cipt 10/7/2012 13:55'!
isOff 
	^isOn not! !

!CiForce methodsFor: 'testing' stamp: 'cipt 10/7/2012 13:55'!
isOn 
	^isOn ! !

!CiForce methodsFor: 'public-api' stamp: 'cipt 10/7/2012 13:55'!
turnOff
	isOn := false.! !

!CiForce methodsFor: 'public-api' stamp: 'cipt 10/7/2012 13:56'!
turnOn
	isOn := true! !

CiForce subclass: #CiSpring
	instanceVariableNames: 'springConstant damping restLength from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics'!

!CiSpring class methodsFor: 'as yet unclassified' stamp: 'cipt 9/26/2012 21:44'!
from: aParticle to: anotherParticle
	^ self new
		initialize;
		from: aParticle;
		to: anotherParticle! !

!CiSpring class methodsFor: 'as yet unclassified' stamp: 'cipt 9/26/2012 23:01'!
from: aParticle to: anotherParticle length: aL k: aSpringCst damping: aD
	^ self new
		initialize;
		from: aParticle;
		to: anotherParticle;
		restLength: aL;
		springConstant: aSpringCst;
		damping: aD! !

!CiSpring methodsFor: 'force-computing' stamp: 'cipt 9/27/2012 21:15'!
apply
	(isOn and: [ from isFree | to isFree ])
		ifTrue: [ 
			| delta distance springForce velocity dampingForce r fromPos toPos|
			fromPos := from position.
			toPos := to position. 
			delta := fromPos - toPos.
			distance := fromPos dist: toPos.
			distance = 0
				ifTrue: [ delta := 0 ]
				ifFalse: [ delta := delta / distance ].
			"spring force is proportional to how much it is stretched"
			springForce := ((distance - restLength) * springConstant) negated.	
			"want velocity along line b/w a & b, damping force is proportional to this"
			velocity := from velocity - to velocity.
			dampingForce := (damping * (velocity dotProduct: velocity)) negated.	
			"forceB is same as forceA in opposite direction"
			r := springForce + dampingForce.
			delta := delta * r.
			from isFree
				ifTrue: [ from force: (from force + delta) ].
			to isFree
				ifTrue: [ to force: (to force - delta) ] ]! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:23'!
currentLength
	^from dist: to! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:25'!
damping
	^damping ! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:25'!
damping: aDamping
	damping  := aDamping ! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:23'!
from
	^from ! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:36'!
from: aParticle
	from := aParticle! !

!CiSpring methodsFor: 'initialize-release' stamp: 'cipt 9/26/2012 21:44'!
initialize 
	super initialize .
	springConstant := 0.2.
	damping := 0.8.
	restLength := 10.
	isOn := true.! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:23'!
restLength 
	^restLength ! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:25'!
restLength: aLength
	restLength := aLength ! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/26/2012 23:03'!
springConstant: aK
	springConstant := aK! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:24'!
strength
	^springConstant ! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:25'!
strength: aStrength
	springConstant := aStrength ! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:23'!
to
	^to! !

!CiSpring methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:36'!
to: aParticle
	to := aParticle! !

Object subclass: #CiIntegrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics'!

CiIntegrator subclass: #CiEulerIntegrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics'!

!CiEulerIntegrator methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 13:39'!
advance: aParticle from: time step: t
	aParticle velocity: aParticle velocity + (aParticle force / aParticle mass * t).
	aParticle position: aParticle position + (aParticle velocity * t)! !

!CiIntegrator class methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 13:43'!
system: aCiSystem
	^ self new
		initialize;
		system: aCiSystem! !

!CiIntegrator methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 13:42'!
advance: aParticle from: aTime step: aDeltaT
	^ self subclassResponsibility! !

CiIntegrator subclass: #CiModifiedEulerIntegrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics'!

!CiModifiedEulerIntegrator methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 13:40'!
advance: aParticle from: aTime step: aT
	| halfTT a |
	halfTT := 0.5 * aT * aT.
	a := aParticle force / aParticle mass.
	aParticle position: aParticle position + (aParticle velocity / aT).
	aParticle position: aParticle position * (a * halfTT).
	aParticle velocity: aParticle velocity + (a / aT)! !

CiIntegrator subclass: #CiRungeKutta4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics'!

!CiRungeKutta4 methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 13:38'!
advance: aParticle from: time step: t
	| state |
	state := CiState
		position: aParticle position
		velocity: aParticle velocity
		force: aParticle force
		mass: aParticle mass.
	self integrate: state time: time delta: t.
	aParticle
		position: state position;
		velocity: state velocity! !

!CiRungeKutta4 methodsFor: 'as yet unclassified' stamp: 'cipt 10/6/2012 22:08'!
integrate: aState time: t delta: aDeltaT
	| a b c d dxdt dvdt |
	a := aState
		derivateWith: CiState new
		time: t
		delta: 0.
	b := aState
		derivateWith: a
		time: t
		delta: (aDeltaT * 0.5).
	c := aState
		derivateWith: b
		time: t
		delta: (aDeltaT * 0.5).
	d := aState
		derivateWith: c
		time: t
		delta: aDeltaT .
	dxdt := 1 / 6 * (a position + (2 * (b position + c position)) + d position).
	dvdt := 1 / 6 * (a velocity + (2 * (b velocity + c velocity)) + d velocity).
	aState position: aState position + (dxdt * aDeltaT).
	aState velocity: aState velocity + (dvdt * aDeltaT)! !

Object subclass: #CiParticle
	instanceVariableNames: 'position velocity force mass age isDead isFixed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics'!

!CiParticle class methodsFor: 'as yet unclassified' stamp: 'cipt 9/26/2012 21:42'!
position: aPos
	^self new initialize ;
		position: aPos! !

!CiParticle class methodsFor: 'as yet unclassified' stamp: 'cipt 10/5/2012 22:15'!
position: aPos mass: aMass
	^self new initialize ;
		position: aPos;
		mass: aMass.! !

!CiParticle class methodsFor: 'as yet unclassified' stamp: 'cipt 9/26/2012 21:33'!
position: aPos velocity: aVel force: aForce
	^self new initialize ;
		position: aPos;
		velocity: aVel;
		force: aForce! !

!CiParticle class methodsFor: 'as yet unclassified' stamp: 'cipt 10/13/2012 15:08'!
x: x y: y
	^ self new
		initialize;
		position: x @ y! !

!CiParticle methodsFor: 'point-functions' stamp: 'cipt 10/7/2012 19:50'!
- anotherParticle
	^ self asPoint - anotherParticle asPoint! !

!CiParticle methodsFor: 'converting' stamp: 'cipt 10/5/2012 20:05'!
adaptToPoint: aPoint andSend: aByteSymbol 
	^aPoint perform: aByteSymbol with: self position! !

!CiParticle methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:40'!
age
	^age! !

!CiParticle methodsFor: 'accessing' stamp: 'cipt 10/2/2012 19:59'!
age: anAge
	age := anAge! !

!CiParticle methodsFor: 'converting' stamp: 'cipt 10/12/2012 23:42'!
asParticle 
	^self! !

!CiParticle methodsFor: 'converting' stamp: 'cipt 10/5/2012 20:14'!
asPoint
	^self position! !

!CiParticle methodsFor: 'point-functions' stamp: 'cipt 10/5/2012 20:13'!
dist: anotherParticle
	
	^self position dist: anotherParticle asPoint! !

!CiParticle methodsFor: 'point-functions' stamp: 'cipt 9/27/2012 21:19'!
dotProduct: aParticle
	^self position dotProduct: aParticle position.! !

!CiParticle methodsFor: 'public-api' stamp: 'cipt 9/25/2012 22:39'!
fix
	isFixed := true.
	velocity := 0@0.! !

!CiParticle methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:40'!
force
	^force! !

!CiParticle methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:41'!
force: aForce 
	force := aForce! !

!CiParticle methodsFor: 'public-api' stamp: 'cipt 9/25/2012 22:39'!
free
	^isFixed := false! !

!CiParticle methodsFor: 'initialization' stamp: 'cipt 10/13/2012 15:20'!
initialize
	super initialize.
	position := 0 @ 0.
	velocity := 0 @ 0.
	force := 0 @ 0.
	mass := 10.
	age := 0.
	isDead := false.
	isFixed := false! !

!CiParticle methodsFor: 'testing' stamp: 'cipt 9/25/2012 22:39'!
isFixed
	^isFixed ! !

!CiParticle methodsFor: 'testing' stamp: 'cipt 9/26/2012 21:53'!
isFree
	^isFixed not ! !

!CiParticle methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:39'!
mass
	^mass! !

!CiParticle methodsFor: 'accessing' stamp: 'cipt 9/27/2012 22:58'!
mass: a
	a = 0
		ifTrue: [  ]
		ifFalse: [ mass := a ]! !

!CiParticle methodsFor: 'point-functions' stamp: 'cipt 10/13/2012 15:17'!
nearestPointAlongLineFrom: aPoint to: anotherPoint
	^ position nearestPointAlongLineFrom: aPoint to: anotherPoint! !

!CiParticle methodsFor: 'accessing' stamp: 'cipt 9/25/2012 22:39'!
position
	^position! !

!CiParticle methodsFor: 'accessing' stamp: 'cipt 10/7/2012 15:20'!
position: anObject
	position := anObject! !

!CiParticle methodsFor: 'printing' stamp: 'cipt 10/5/2012 22:12'!
printOn: aStream
	aStream nextPutAll: 'p(', self position printString ,')'.! !

!CiParticle methodsFor: 'initialization' stamp: 'cipt 9/25/2012 22:41'!
reset
	age := 0.
	isDead := false.
	position := 0@0.
	velocity := 0@0.
	force := 0@0.
	mass := 1.0.! !

!CiParticle methodsFor: 'point-functions' stamp: 'cipt 10/5/2012 20:59'!
squaredDistanceTo: anotherParticle 
	^self position squaredDistanceTo: anotherParticle position! !

!CiParticle methodsFor: 'accessing' stamp: 'cipt 9/26/2012 21:54'!
velocity
	^ velocity! !

!CiParticle methodsFor: 'accessing' stamp: 'cipt 9/26/2012 21:54'!
velocity: anObject
	velocity := anObject! !

!CiParticle methodsFor: 'point-functions' stamp: 'cipt 10/5/2012 20:09'!
x
	^self position x! !

!CiParticle methodsFor: 'point-functions' stamp: 'cipt 10/5/2012 20:09'!
y
	^self position y! !

Object subclass: #CiParticleSystem
	instanceVariableNames: 'particles springs attractions integrator friction gravity eventHandler deltaT sinker stopCondition iterations'
	classVariableNames: 'TheProcess'
	poolDictionaries: ''
	category: 'CiSics'!

!CiParticleSystem class methodsFor: 'as yet unclassified' stamp: 'cipt 10/1/2012 22:22'!
TheProcess
	^TheProcess! !

!CiParticleSystem class methodsFor: 'as yet unclassified' stamp: 'cipt 9/27/2012 20:42'!
TheProcess: aProc
	TheProcess := aProc! !

!CiParticleSystem methodsFor: 'simulation' stamp: 'cipt 10/7/2012 13:40'!
advanceTime: aTime with: aDelta
	self clearForces.
	self applyForces.
	self particles
		do: [ :particle | 
			particle isFree
				ifTrue: [ integrator advance: particle from: aTime step: aDelta ] ]! !

!CiParticleSystem methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 14:34'!
announce: event
	eventHandler announce: event! !

!CiParticleSystem methodsFor: 'simulation' stamp: 'cipt 10/5/2012 22:07'!
applyForces
	self particles
		do: [ :each | 
			each force: each force + (each velocity * friction negated).
			each force: each force + gravity ].
	self springs isNil ifFalse: [ self springs do: [ :each | each apply ]].
	self attractions isNil ifFalse:[self attractions do: [ :each | each apply ]]! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:52'!
attractions
	^ attractions! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 10/5/2012 20:52'!
attractions: anObject
	attractions := anObject! !

!CiParticleSystem methodsFor: 'simulation' stamp: 'cipt 10/1/2012 22:08'!
clearForces
	self particles do: [ :each | each force: 0@0. ].

! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 10/7/2012 15:02'!
deltaT
	^ deltaT! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 10/7/2012 15:02'!
deltaT: anObject
	deltaT := anObject! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 10/5/2012 22:34'!
friction: aSmallInteger 
	friction := aSmallInteger! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 10/5/2012 22:44'!
gravity: aSmallInteger 
	gravity := aSmallInteger! !

!CiParticleSystem methodsFor: 'initialize-release' stamp: 'cipt 10/13/2012 16:17'!
initialize
	super initialize.
	integrator := CiRungeKutta4 new.
	friction := (0.5).
	gravity := 0.
	eventHandler  := Announcer new.
	deltaT := 1/60.
	iterations := 50.
! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 10/7/2012 13:44'!
integrator
	^ integrator! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 10/7/2012 13:44'!
integrator: anObject
	integrator := anObject! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 10/12/2012 21:45'!
iterations: a
	iterations := a.! !

!CiParticleSystem methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 14:38'!
on: event do: aBlock
	eventHandler when: event do: aBlock! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 9/26/2012 21:36'!
particles
	^ particles! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 9/26/2012 21:36'!
particles: anObject
	particles := anObject! !

!CiParticleSystem methodsFor: 'simulation' stamp: 'cipt 10/7/2012 20:01'!
simulate
	| process |
	process := self simulationProcess fork.
	self class TheProcess: process! !

!CiParticleSystem methodsFor: 'simulation' stamp: 'cipt 10/13/2012 00:09'!
simulationProcess
	^ [ 
	| time |
	time := 0.
	'CiSics iteration: '
		displayProgressFrom: 0
		to: iterations * deltaT
		during: [ :bar | 
			self stopCondition
				whileFalse: [ 
					bar value: time.
					self advanceTime: time with: deltaT.
					time := time + deltaT.
					self announce: CiSystemChanged ] ] ]! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 10/7/2012 15:49'!
springs
	^ springs isNil
		ifTrue: [ OrderedCollection new ]
		ifFalse: [ springs ]! !

!CiParticleSystem methodsFor: 'accessing' stamp: 'cipt 9/26/2012 21:36'!
springs: anObject
	springs := anObject! !

!CiParticleSystem methodsFor: 'simulation' stamp: 'cipt 10/7/2012 20:02'!
stopCondition
	^ stopCondition isNil
		ifTrue: [ [ false ] ]
		ifFalse: [ stopCondition ]! !

!CiParticleSystem methodsFor: 'simulation' stamp: 'cipt 10/7/2012 19:57'!
stopCondition: aBlock
	stopCondition := aBlock! !

Object subclass: #CiParticleSystemView
	instanceVariableNames: 'system showSprings view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics-Roassal'!

!CiParticleSystemView methodsFor: 'accessing' stamp: 'cipt 10/12/2012 23:28'!
initialize 
	super initialize .
	showSprings := true.
	view := (ROView titled: 'CiSics Viewer') backgroundColor: Color white .! !

!CiParticleSystemView methodsFor: 'accessing' stamp: 'cipt 10/7/2012 15:58'!
open
	| w |
	w := view open.
	w announcer
		on: WindowClosed
		do: [ :evt | system class TheProcess terminate ]! !

!CiParticleSystemView methodsFor: 'accessing' stamp: 'cipt 10/14/2012 15:21'!
showAttractions
system attractions isNil ifFalse:[
	view
		addAll:
			(system attractions 
				collect: [ :attraction  | 
					| e |
					e := ROEdge from: (view elementFromModel: attraction a) to: (view elementFromModel: attraction b).
					e + ROLine green ])]! !

!CiParticleSystemView methodsFor: 'accessing' stamp: 'cipt 10/12/2012 23:25'!
showParticles
	view
		addAll:
			(system particles
				collect: [ :particle | 
					| e |
					e := ROElement on: particle.
					e + (ROCircle color: "(Color gray256: ((particle mass/10)*150))" Color black).
					e extent: 7 @ 7.
					e center: particle position.
					e @ RODraggable.
					e
						on: ROMouseLeftClick
						do: [ :ev | 
							particle isFree
								ifTrue: [ particle fix ]
								ifFalse: [ particle free ] ].
					e
						on: ROMouseDragging
						do: [ :ev | 
							particle fix.
							particle position: ev position ].
					e
						on: ROMouseDragged
						do: [ :ev | particle free ].
					e ])! !

!CiParticleSystemView methodsFor: 'accessing' stamp: 'cipt 10/14/2012 14:43'!
showSprings
	showSprings
		ifTrue: [ 
			view
				addAll:
					(system springs
						collect: [ :spring | 
							| e |
							e := ROEdge from: (view elementFromModel: spring from) to: (view elementFromModel: spring to).
							e + ROLine red ]) ]! !

!CiParticleSystemView methodsFor: 'accessing' stamp: 'cipt 10/7/2012 14:48'!
system
	^ system! !

!CiParticleSystemView methodsFor: 'accessing' stamp: 'cipt 10/14/2012 14:20'!
system: anObject
	| nodes |
	system := anObject.
	self showParticles .
	self showSprings.
	self showAttractions .
	self updateHandler .
	view
		on: ROMouseRightClick
		do: [ :ev | CiParticleSystem TheProcess terminate ]! !

!CiParticleSystemView methodsFor: 'accessing' stamp: 'cipt 10/14/2012 14:41'!
updateHandler
	system
		on: CiSystemChanged
		do: [ :evt | 
			system particles
				do: [ :p | 
					| el |
					el := view elementFromModel: p.
					el isNil
						ifFalse: [ el center: p position ] ].
			view signalUpdate ]! !

Object subclass: #CiState
	instanceVariableNames: 'position velocity force mass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CiSics'!

!CiState class methodsFor: 'as yet unclassified' stamp: 'cipt 10/6/2012 21:15'!
position: aPosition velocity: aVelocity
	^ self new
		initialize;
		position: aPosition;
		velocity: aVelocity! !

!CiState class methodsFor: 'as yet unclassified' stamp: 'cipt 10/6/2012 21:49'!
position: aPosition velocity: aVelocity force: aForce mass: aMass
	^ self new
		initialize;
		position: aPosition;
		velocity: aVelocity;
		force: aForce ;
		mass: aMass .! !

!CiState methodsFor: 'as yet unclassified' stamp: 'cipt 10/7/2012 16:05'!
derivateWith: aDerivative time: aTime delta: aDeltaT
	| newP newV |
	newP := position + (aDerivative position * aDeltaT).
	newV := velocity + (aDerivative velocity * aDeltaT).
	^ (CiState position: newV velocity: force / mass)
		force: force;
		mass: mass! !

!CiState methodsFor: 'accessing' stamp: 'cipt 10/6/2012 21:47'!
force
	^ force! !

!CiState methodsFor: 'accessing' stamp: 'cipt 10/6/2012 21:47'!
force: anObject
	force := anObject! !

!CiState methodsFor: 'as yet unclassified' stamp: 'cipt 10/6/2012 21:29'!
initialize 
	super initialize .
	position := 0@0.
	velocity := 0@0.! !

!CiState methodsFor: 'accessing' stamp: 'cipt 10/6/2012 21:47'!
mass
	^ mass! !

!CiState methodsFor: 'accessing' stamp: 'cipt 10/6/2012 21:47'!
mass: anObject
	mass := anObject! !

!CiState methodsFor: 'accessing' stamp: 'cipt 10/6/2012 21:07'!
position
	^ position! !

!CiState methodsFor: 'accessing' stamp: 'cipt 10/6/2012 21:07'!
position: anObject
	position := anObject! !

!CiState methodsFor: 'accessing' stamp: 'cipt 10/6/2012 21:07'!
velocity
	^ velocity! !

!CiState methodsFor: 'accessing' stamp: 'cipt 10/6/2012 21:07'!
velocity: anObject
	velocity := anObject! !
